/*
 *  Copyright 2010 Chet Haase
 *	
 *	Licensed under the Apache License, Version 2.0 (the "License");
 *	you may not use this file except in compliance with the License.
 *	You may obtain a copy of the License at
 *	
 *	http://www.apache.org/licenses/LICENSE-2.0
 *	
 *	Unless required by applicable law or agreed to in writing, software
 *	distributed under the License is distributed on an "AS IS" BASIS,
 *	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *	See the License for the specific language governing permissions and
 *	limitations under the License.
 */
package utils
{
import flash.geom.Point;

import spark.effects.interpolation.IInterpolator;

public class PointInterpolator implements IInterpolator
{
    public function interpolate(fraction:Number, startValue:Object, endValue:Object):Object
    {
        var startPoint:Point = Point(startValue);
        var endPoint:Point = Point(endValue);
        return new Point(startPoint.x + fraction * (endPoint.x - startPoint.x),
            startPoint.y + fraction * (endPoint.y - startPoint.y));
    }
    
    public function increment(baseValue:Object, incrementValue:Object):Object
    {
        var basePoint:Point = Point(baseValue);
        var incrementPoint:Point = Point(incrementValue);
        return new Point(basePoint.x + incrementPoint.x,
            basePoint.y + incrementPoint.y);
    }
    
    public function decrement(baseValue:Object, decrementValue:Object):Object
    {
        var basePoint:Point = Point(baseValue);
        var decrementPoint:Point = Point(decrementValue);
        return new Point(basePoint.x - decrementPoint.x,
            basePoint.y - decrementPoint.y);
    }
    
}
}